//+------------------------------------------------------------------+
//|                                           PrepareArrayPixels.mq5 |
//|                              Copyright  2015, Vladimir Karputov |
//|                                           http://wmua.ru/slesar/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, Vladimir Karputov"
#property link      "http://wmua.ru/slesar/"
#property version   "1.00"
#property description "Demonstration of a block of code ""prepare the array of pixels"""
#property script_show_inputs
#include <Canvas\Canvas.mqh>
//+------------------------------------------------------------------+
//| inputs                                                           |
//+------------------------------------------------------------------+
input color colr=clrBlue;
//--- variable width and height of the chart
int   ChartWidth=-1;
int   ChartHeight=-1;
//---
uchar    alpha=20;               //alpha channel managing color transparency
int      split=50;               //split between canvas and edges of chart
int      can_width,can_height;   //width and height of the canvas
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
int OnStart()
  {
   int X1,Y1; //coordinates
//--- width and height of the chart
   can_width=ChartWidthInPixels()-(split*2);
   can_height=ChartHeightInPixelsGet()-(split*2);
//---
   X1=can_width/2-50;      Y1=can_height/2-50;
//--- COLOR_FORMAT_ARGB_NORMALIZE
   CCanvas canvas_;
   if(!canvas_.CreateBitmapLabel("canvas_",split,split,can_width,can_height,COLOR_FORMAT_ARGB_NORMALIZE))
     {
      Print("Error creating canvas: ",GetLastError());
      return(-1);
     }
   canvas_.Erase(ColorToARGB(clrWhite,255));
//--- create four huge pixels
//+------------------------------------------------------------------+
//|                                                                  |
//|                    (X1;Y1)+-----+-----+                          |
//|                           |     |     |                          |
//|                           |     |     |                          |
//|                           +-----+-----+                          |
//|                           |     |     |                          |
//|                           |     |     |                          |
//|                           +-----+-----+(X1+100;Y1+100)           |
//|                                                                  |
//+------------------------------------------------------------------+
   double   dx=0.0,dy=0.0; // increment
   uint     X1Y1,X1Y2,X2Y1,X2Y2; // colors
   for(int i=0;i<100;i++)
     {
      canvas_.PixelSetAA(5+dx,5+dy,ColorToARGB(colr,255));
      X1Y1=canvas_.PixelGet(5,5);
      X1Y2=canvas_.PixelGet(5,6);
      X2Y1=canvas_.PixelGet(6,5);
      X2Y2=canvas_.PixelGet(6,6);
      canvas_.FillRectangle(X1,Y1,X1+50,Y1+50,X1Y1);
      canvas_.FillRectangle(X1+50,Y1,X1+100,Y1+50,X1Y2);
      canvas_.FillRectangle(X1,Y1+50,X1+50,Y1+100,X2Y1);
      canvas_.FillRectangle(X1+50,Y1+50,X1+100,Y1+100,X2Y2);
      dx+=0.01;dy+=0.01;
      canvas_.Update();
      Sleep(50);
      canvas_.Erase(ColorToARGB(clrWhite,255));
     }
   Comment("dx=",dx);
   canvas_.Update();
   Sleep(1000);
//--- finish
   canvas_.Destroy();
   return(0);
  }
//+------------------------------------------------------------------+
//| Chart property width                                             |
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
//--- prepare the variable to get the property value
   long result=-1;
//--- reset the error value
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//--- return the value of the chart property
   return((int)result);
  }
//+------------------------------------------------------------------+
//| Chart property height                                            |
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
//--- prepare the variable to get the property value
   long result=-1;
//--- reset the error value
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//--- return the value of the chart property
   return((int)result);
  }
//+------------------------------------------------------------------+
